<template>
    <q-card class="pacard">
      <q-card-section>
         <q-avatar size="100px">
      <img :src="'http://localhost:3000/images/'+ patient.foto">
    </q-avatar>
    <br>
        <p class="text-subtitle2">{{patient.naam}}</p>
        <p class="text-h6">Info</p>
      <q-separator />
      <p class="text-body1">Afdeling: {{afdelingNaam}}</p>
       <p class="text-body1">Kamernummer: {{kamerNummer}}</p>
       <p class="text-body1">Datum: {{patient.datumOpname}}</p>
       <p class="text-body1">Reden: {{patient.redenOpname}}</p>
       <p class="text-body1">Behandelende arts: {{patient.arts}}</p>
        <q-toggle class="text-body2"
        v-model="patient.Vegetarisch"
        @input="$emit('updatePatient', patient.Vegetarisch)"
        label="Vegetarisch"
        left-label
      />
      <p class="text-h6">Opmerkingen <q-btn flat rounded dense color="secondary" icon="add" @click="dialogOpm = true" /></p>
      <q-separator />
<q-list bordered class="rounded-borders list">
      <q-item  v-for="opm in patient.opmerkingen"
      :key="opm">
        <q-item-section>
          <q-item-label >{{opm}}</q-item-label>
        </q-item-section>
        <q-item-section side>
            <q-btn class="gt-xs" size="12px" color="red" @click="$emit('deleteOpm', opm)" flat dense round icon="clear" />
        </q-item-section>
      </q-item>
</q-list>
      <p class="text-h6">Acties <q-btn flat rounded dense color="secondary" icon="add" @click="type = 'add';showDialog()" /></p>
      <q-separator />
      <q-checkbox  v-model="verbergenUitgevoerdeActies"
         label="Uitgevoerde Acties Verbergen" />
<q-markup-table>
      <thead>
        <tr>
          <th class="text-left">Type</th>
          <th class="text-center">Omschrijving</th>
          <th class="text-center">Tijdstip</th>
          <th class="text-center">Uitgevoerd?</th>
          <th class="text-center"></th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="actie in getActies" :key="actie.id">
          <td class="text-left">{{actie.type}}</td>
          <td class="text-center">{{actie.omschrijving}}</td>
          <td class="text-center">{{actie.tijdstip}}</td>
          <td class="text-center"><q-checkbox v-model="actie.uitgevoerd" @input="$emit('uitgevoerd',actie)"/></td>
          <td class="text-center" v-show="options.includes(actie.type)">
            <q-btn flat rounded dense color="blue" icon="edit" @click="actieT = actie;type = 'edit';showDialog()" />
          <q-btn flat rounded dense color="red" icon="clear" @click="$emit('deleteActie',actie)" />
          </td>
          <td class="text-center" v-show="!options.includes(actie.type)">
          </td>
        </tr>
      </tbody>
    </q-markup-table>

      </q-card-section>
      <CommentDialog v-bind:show="dialogOpm" v-on:hideDialog="dialogOpm = false" v-on:addOpm="$emit('addOpm',$event)"></CommentDialog>
     <ActionDialog v-bind:show="dialogActie" v-bind:actie="actieT" v-bind:type="type" v-on:hideDialog="dialogActie = false" v-on:addActie="$emit('addActie',$event)" v-on:editActie="$emit('editActie',$event)"></ActionDialog>
    </q-card>
</template>

<script>
import CommentDialog from './CommentDialog'
import ActionDialog from './ActionDialog'
import AfdelingService from '../services/AfdelingService'
import KamerService from '../services/KamerService'
export default {
  name: 'PatientCard',
  components: {
    CommentDialog, ActionDialog
  },
  data () {
    return {
      options: [
        'Eten', 'Wassen', 'Omkeren'
      ],
      kamerNummer: Number,
      afdelingNaam: '',
      data: this.acties,
      dialogOpm: false,
      dialogActie: false,
      actieT: {
        type: '',
        omschrijving: '',
        tijdstip: '',
        uitgevoerd: false,
        patientId: 0
      },
      verbergenUitgevoerdeActies: false,
      type: 'add'
    }
  },
  props: {
    patient: [Object, Array],
    patientId: String,
    acties: Array
  },
  methods: {
    // dit is zodat de actieDialog component verschijnt
    showDialog () {
      this.dialogActie = true
    },
    // kamer en afdeling nummer ophalen en laten zien
    async getKamerNummer () {
      let array = await this.kamerservice.getByPatientId(this.patientId)
      this.kamerNummer = array[0].id
      let afd = await this.afdelingservice.getById(array[0].afdelingId)
      this.afdelingNaam = afd.naam
    }
  },
  created () {
    this.kamerservice = new KamerService()
    this.afdelingservice = new AfdelingService()
    this.getKamerNummer()
  },
  computed: {
    getActies: function () {
      if (this.verbergenUitgevoerdeActies) {
        return this.acties.filter(uitgevoerd)
      }
      return this.acties
    }
  }
}
function uitgevoerd (obj) {
  return obj.uitgevoerd === false
}
</script>

<style scoped>
.pacard {
  text-align: center
}

.list {
  max-width: 600px
}
</style>
